#include<bits/stdc++.h>
using namespace std;
long long NZD(long long a, long long b)
{
   if (b==0)
   return a;
   return NZD(b, a%b);
}
long long NZDN(long long a[],long long n)
{
    for(int i=1;i<n;i++)
        a[i]=NZD(a[i],a[i-1]);
    return a[n-1];
}
int main()
{
    int T;
    cin>>T;
    for(int i=0;i<T;i++)
    {
        long long n,m;
        cin>>n>>m;
        long long a[n];
        long long b[m];
        for(int j=0;j<n;j++)
            cin>>a[i];
        for(int j=0;j<m;j++)
            cin>>b[i];
        long long razA[n-1];
        for(int j=0;j<n-1;j++)
            razA[j]=abs(razA[j]-razA[j+1]);
        long long razB[m-1];
        for(int j=0;j<m-1;j++)
            razB[j]=abs(razB[j]-razB[j+1]);
        long long na=NZDN(razA,n);
        long long nb=NZDN(razB,m);
        if(na>nb)
            cout<<0;
        else if(na<=nb && nb%na==0 && abs(a[0]-b[0])%na==0)
            cout<<1;
        else if(na<nb && nb%na==0)
            cout<<0;
        else cout<<0;
        cout<<endl;
    }
}